#!/bin/bash

# set -x # Handle all errors here - remove -x before shipping 

# *****************************************************************
#
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2019. All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# *****************************************************************
POWERAI_LICENSE_DIR=".powerai"
export POWERAI_LICENSE_DIR
POWERAI_LICENSE_REL="1.6.0"
export POWERAI_LICENSE_REL
IBM_WMLA_REL="1.2.0"

if [[ -n $PREFIX ]]; then
  STATUS_FILE=${HOME}/$POWERAI_LICENSE_DIR/powerai-license/${POWERAI_LICENSE_REL}/license/status.dat
  WMLA_STATUS_FILE=${HOME}/$POWERAI_LICENSE_DIR/ibm-wmla-license/${IBM_WMLA_REL}/license/status.dat
  if [[ -s $STATUS_FILE || -s $WMLA_STATUS_FILE || -s accept-ibm-wmla-license.sh ]]; then
    RC=0 # License was previously accepted - nothing to do
  else
    exec {TTY_FD}<>/dev/tty ; RC=$? ; exec {TTY_FD}>&- # Make sure we have a controlling terminal
    if [[ $RC == 0 || $IBM_POWERAI_LICENSE_ACCEPT == 'yes' ]]; then

      exec {STDIN_FD}<&0 ; exec {STDOUT_FD}>&1 ; exec {STDERR_FD}>&2

      exec </dev/tty ; exec >/dev/tty 2>&1 ; set +x ; mkdir -p $HOME/$POWERAI_LICENSE_DIR/powerai-license/$POWERAI_LICENSE_REL ; bash .powerai-license-accept.sh ; RC=$?

      exec <&$STDIN_FD ; exec 1>&$STDOUT_FD ; exec 2>&$STDERR_FD
      exec {STDIN_FD}<&- ; exec {STDOUT_FD}>&- ; exec {STDERR_FD}>&-

      if [[ $RC == 9 ]]; then
        RC=0
      elif [[ $RC == 1 ]]; then
        echo "License NOT accepted. Installation will not proceed." >> $PREFIX/.messages.txt
      fi
    else
      echo "The PowerAI license must be accepted during installation. To accept the license during non-interactive install, use \"export IBM_POWERAI_LICENSE_ACCEPT=yes\"" >> $PREFIX/.messages.txt
    fi
  fi
else
  echo "${PREFIX}" >> $PREFIX/.messages.txt
  echo "Install prefix not set." >> $PREFIX/.messages.txt
  RC=1
fi

unset POWERAI_LICENSE_DIR
unset POWERAI_LICENSE_REL

[ ! -z $POWERAI_LICENSE_TRACE ] && echo "Post-link RC: $RC" >> /tmp/powerai-license.log

exit $RC
